#ifndef EAVESDROPPER_MAIN_H
#define EAVESDROPPER_MAIN_H

// ***************************************************************************
// System Includes
// ***************************************************************************

#include <be/interface/GraphicsDefs.h>

// ***************************************************************************
// Project Includes
// ***************************************************************************

#include "StyleGuideDefs.h"         // Standard type and constant definitions.

#define  BUGS_B_GONE
#define  BBG_PREFIX "Eavesdropper"
#include "Bugs-B-Gone.h"

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

enum
{
	/** The message that is sent by the "Refresh" menu item. */
	MSG_REFRESH = 1000000,
	
	/** The message that is sent by the "Clean up" menu item. */
	MSG_CLEAN_UP,
	
	/** The message that is sent when a node is dropped on a view. */
	MSG_DRAG_NODE,
};

// Colors used by the various views.
const rgb_color COLOR_BACKGROUND = {255, 255, 255, 0};
const rgb_color COLOR_TEXT       = {  0,   0,   0, 0};
const rgb_color COLOR_TAB        = {200, 240, 240, 0};
const rgb_color COLOR_NODE       = {230, 255, 255, 0};
const rgb_color COLOR_BORDER     = {  0,   0,   0, 0};
const rgb_color COLOR_ROLLOVER   = {255, 203,   0, 0};
const rgb_color COLOR_SELECTED   = {  0,   0, 255, 0};
const rgb_color COLOR_FREE       = {230, 255, 255, 0};
const rgb_color COLOR_CONNECTED  = {166, 185, 185, 0};
const rgb_color COLOR_CONNECTION = {255,   0,   0, 0};

/** The full path name of the settings file. */
extern const char* SETTINGS_FILE;

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

#endif // EAVESDROPPER_MAIN_H
