// ***************************************************************************
// Implementation System Includes
// ***************************************************************************

// ***************************************************************************
// Implementation Project Includes
// ***************************************************************************

#include "IconFactory.h"

// ***************************************************************************
// Implementation Constant Definitions
// ***************************************************************************

/** The width of the icons. */
static const int32 ICON_WIDTH = 16;

/** The height of the icons. */
static const int32 ICON_HEIGHT = 16;

/** The size of an icon in bytes. */
static const int32 ICON_SIZE = ICON_WIDTH * ICON_HEIGHT;

/** The color space of the icons. */
static const color_space ICON_COLOR_SPACE = B_COLOR_8_BIT;

/** The buffer producer icon. */
static const unsigned char BUFFER_PRODUCER_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0x0f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x12,0x00,0x12,0x0f,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x12,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x12,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x12,0x00,0x00,0x00,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x12,0x00,0x00,0x00,0x00,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x12,0x12,0x00,0x00,0x00,0x00,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0x12,0x00,0x00,0x00,
	0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0x12,0x00,0x12,
	0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x3f,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x3f,0x12,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

/** The buffer consumer icon. */
static const unsigned char BUFFER_CONSUMER_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x08,0x10,0x08,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x14,0x1b,0x10,0x08,0x08,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x18,0x3f,0x14,0x08,0x10,0x18,0x08,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x1b,0x3f,0x18,0x00,0x14,0x3f,0x10,0x08,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x1b,0x00,0x18,0x3f,0x14,0x08,0x10,0x08,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x1b,0x3f,0x18,0x00,0x14,0x1b,0x10,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x3f,0x1b,0x00,0x18,0x3f,0x14,0x08,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x3f,0x3f,0x1b,0x3f,0x18,0x00,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x1b,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0x08,0x3f,0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
	0xff,0xff,0x10,0x10,0x3f,0x3f,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x08,0x18,0x3f,0x3f,0x3f,0x08,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x08,0x1b,0x3f,0x3f,0x3f,0x10,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x3f,0x3f,0x3f,0x18,0x10,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0x00,0x18,0x3f,0x1b,0x08,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x00,0x08,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

/** The time source icon. */
static const unsigned char TIME_SOURCE_ICON[] =
{
	0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x6d,0x6d,0x47,0x47,0x47,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x00,0x6d,0x94,0x94,0x3f,0x3f,0x47,0x6d,0x94,0x00,0xff,0xff,0xff,0xff,
	0xff,0x00,0x94,0x94,0x00,0x00,0x00,0x94,0x3f,0x94,0x94,0x00,0xff,0xff,0xff,0xff,
	0xff,0x00,0x94,0x00,0x3f,0x86,0x86,0x00,0x94,0x6d,0x94,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x00,0x3f,0x60,0x00,0x86,0x86,0x00,0x94,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x00,0x60,0x60,0x00,0x60,0x86,0x00,0x94,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x00,0x60,0x60,0x00,0x60,0x60,0x86,0x00,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x00,0x60,0x60,0x00,0x00,0x60,0x86,0x00,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x00,0x86,0x60,0x60,0x60,0x00,0x86,0x00,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x94,0x00,0x86,0x86,0x86,0x86,0x00,0x94,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0x00,0x94,0x94,0x94,0x00,0x00,0x00,0x00,0x94,0x94,0x7f,0x7f,0x00,0xff,0xff,0xff,
	0xff,0x00,0x00,0x94,0x94,0x94,0x94,0x94,0x94,0x94,0x7f,0x7f,0x00,0x0f,0x0f,0xff,
	0xff,0xff,0xff,0x00,0x00,0x94,0x94,0x94,0x94,0x94,0x7f,0x00,0x00,0x0f,0x0f,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x94,0x94,0x00,0x00,0x0f,0x0f,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x0e,0x0f,0xff,0xff,0xff
};

/** The controllable icon. */
static const unsigned char CONTROLLABLE_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x0f,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0xfc,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x0f,0xbd,0xbd,0xbd,0xbd,0xbd,0xbd,0xbd,0x0f,0x0f,0x0f,0x0f,0x0f,0xff,0xff,
	0xff,0x0f,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x19,0x00,0xff,0xff,
	0xff,0x0f,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x19,0x00,0xff,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

/** The file interface icon. */
static const unsigned char FILE_INTERFACE_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x00,0x3f,0x60,0x60,0x60,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x3f,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0xff,0xff,0xff,
	0xff,0xff,0x00,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x3f,0x60,0x60,0x00,0x00,0xff,
	0xff,0x00,0x3f,0x60,0x3f,0x60,0x3f,0x60,0x3f,0x60,0x3f,0x3f,0x60,0x60,0x00,0x00,
	0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x1b,0x60,0x00,0x00,0xae,
	0xae,0x00,0x00,0x87,0x87,0x87,0x87,0x87,0x87,0x87,0x87,0x87,0x01,0x87,0x00,0x00,
	0xff,0xae,0x00,0x00,0x00,0x87,0x87,0x87,0x87,0x87,0x87,0x00,0x87,0x00,0xae,0xae,
	0xff,0xff,0xae,0x00,0xae,0x00,0x00,0xae,0xae,0xae,0x00,0x00,0x00,0xae,0xff,0xff,
	0xff,0xff,0xff,0xae,0x00,0x87,0xae,0x00,0xae,0x00,0xae,0xae,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xae,0x00,0x00,0x00,0x00,0xae,0xae,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xae,0x00,0xae,0xff,0xae,0xff,0xff,0xff,0xff,0xff,0xff
};

/** The physical input icon. */
static const unsigned char PHYSICAL_INPUT_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x10,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x10,0x00,0x00,0x3f,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x00,0x10,0x00,0x10,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x10,0x00,0x10,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0x00,0x10,0x00,0x00,0x18,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x00,0x10,0x10,0x18,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x10,0x10,0x18,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x10,0x10,0x18,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x10,0x10,0x18,0x00,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x10,0x10,0x18,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x10,0x10,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x10,0x00,0x00,0x00,0xff,0xff,0xff,0x00,0x10,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0xff,0xff,0xff,0x00,0x00,0x00,0x10,0xff,0xff
};

/** The physical output icon. */
static const unsigned char PHYSICAL_OUTPUT_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x8b,0x10,0x00,0x10,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x8b,0xfa,0x00,0x18,0x18,0x18,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x8b,0xfa,0x10,0x10,0x18,0x3f,0x10,0xff,0xff,0xff,0x10,0xff,
	0xff,0xff,0xff,0x8b,0xfa,0x3f,0x00,0x18,0x3f,0x3f,0x10,0xff,0xff,0x10,0xff,0xff,
	0xff,0x8b,0x8b,0xfa,0x3f,0xfa,0x00,0x18,0x3f,0x3f,0x10,0xff,0x10,0xff,0xff,0xff,
	0x8b,0x3f,0x18,0x3f,0xfa,0x3f,0x00,0x00,0x3f,0x3f,0x10,0xff,0xff,0xff,0xff,0xff,
	0x8b,0xfa,0x18,0xfa,0x3f,0xfa,0x00,0x18,0x00,0x3f,0x10,0xff,0xff,0xff,0xff,0xff,
	0x8b,0xfa,0x18,0x3f,0xfa,0x3f,0x00,0x10,0x00,0x3f,0x10,0xff,0x10,0x10,0x10,0x10,
	0x00,0x8b,0x10,0xfa,0x3f,0xfa,0x00,0x00,0x3f,0x3f,0x10,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x00,0x8b,0xfa,0x3f,0x00,0x18,0x3f,0x3f,0x10,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x8b,0xfa,0x00,0x18,0x3f,0x3f,0x10,0xff,0x10,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x00,0x8b,0x10,0x10,0x3f,0x3f,0x10,0xff,0xff,0x10,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x8b,0x00,0x18,0x18,0x10,0xff,0xff,0xff,0x10,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x8b,0x00,0x10,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

/** The system mixer icon. */
static const unsigned char SYSTEM_MIXER_ICON[] =
{
	0xff,0xff,0xff,0xff,0xff,0xff,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x17,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0x00,0x17,0x17,0x18,0x3f,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x17,0x17,0x31,0x18,0x00,0x3f,0x3f,0x00,0x00,0xff,0xff,0xff,
	0xff,0xff,0x00,0x17,0x17,0x18,0x3f,0x17,0x17,0x00,0x00,0x3f,0x3f,0x00,0x00,0xff,
	0xff,0x00,0x17,0x17,0x31,0x18,0x00,0x3f,0x3f,0x17,0x17,0x00,0x00,0x18,0x17,0x00,
	0x00,0x17,0x18,0x17,0x3f,0x17,0x17,0x00,0x00,0x3f,0x3f,0x17,0x17,0x18,0x0a,0x00,
	0x00,0x3f,0x31,0x17,0x00,0x3f,0x3f,0x17,0x17,0x00,0x00,0x18,0x17,0x0b,0x04,0x00,
	0x00,0x17,0x18,0x3f,0x3f,0x00,0x00,0x3f,0x3f,0x17,0x17,0x18,0x0a,0x05,0x0a,0x00,
	0x00,0x11,0x11,0x18,0x17,0x3f,0x3f,0x00,0x00,0x17,0x17,0x0b,0x04,0x0b,0x00,0x0f,
	0x00,0x04,0x04,0x11,0x11,0x18,0x17,0x3f,0x3f,0x17,0x0b,0x04,0x0a,0x00,0x0f,0xff,
	0x00,0x11,0x11,0x04,0x04,0x11,0x11,0x17,0x18,0x0a,0x05,0x0a,0x00,0x0f,0xff,0xff,
	0xff,0x00,0x00,0x11,0x11,0x04,0x04,0x11,0x0b,0x04,0x0b,0x00,0x0e,0xff,0xff,0xff,
	0xff,0xff,0xff,0x00,0x00,0x11,0x11,0x04,0x04,0x0b,0x00,0x0f,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x11,0x0a,0x00,0x0f,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x0e,0xff,0xff,0xff,0xff,0xff,0xff
};

// ***************************************************************************
// Implementation Type Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Variable Definitions
// ***************************************************************************

// Initialize the static member variables.
BBitmap* IconFactory::bufferProducerBitmap = 0;
BBitmap* IconFactory::bufferConsumerBitmap = 0;
BBitmap* IconFactory::timeSourceBitmap = 0;
BBitmap* IconFactory::controllableBitmap = 0;
BBitmap* IconFactory::fileInterfaceBitmap = 0;
BBitmap* IconFactory::physicalInputBitmap = 0;
BBitmap* IconFactory::physicalOutputBitmap = 0;
BBitmap* IconFactory::systemMixerBitmap = 0;

// ***************************************************************************
// Implementation Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Variable Definitions
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions
// ***************************************************************************

// ===========================================================================
// Initialize
// ===========================================================================

void
IconFactory::Initialize()
{
	BRect bitmapSize(0, 0, 15, 15);

	bufferProducerBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	bufferProducerBitmap->SetBits(BUFFER_PRODUCER_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	bufferConsumerBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	bufferConsumerBitmap->SetBits(BUFFER_CONSUMER_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	timeSourceBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	timeSourceBitmap->SetBits(TIME_SOURCE_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	controllableBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	controllableBitmap->SetBits(CONTROLLABLE_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	fileInterfaceBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	fileInterfaceBitmap->SetBits(FILE_INTERFACE_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	physicalInputBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	physicalInputBitmap->SetBits(PHYSICAL_INPUT_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	physicalOutputBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	physicalOutputBitmap->SetBits(PHYSICAL_OUTPUT_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);

	systemMixerBitmap = new BBitmap(bitmapSize, ICON_COLOR_SPACE);
	systemMixerBitmap->SetBits(SYSTEM_MIXER_ICON,
		ICON_SIZE,
		0,
		ICON_COLOR_SPACE);
}

// ===========================================================================
// GetBitmapFor
// ===========================================================================

BBitmap*
IconFactory::GetBitmapFor(Icon icon) 
{
	switch (icon)
	{
		case BUFFER_PRODUCER:
		{
			return bufferProducerBitmap;
		}
		case BUFFER_CONSUMER:
		{
			return bufferConsumerBitmap;
		}
		case TIME_SOURCE:
		{
			return timeSourceBitmap;
		}
		case CONTROLLABLE:
		{
			return controllableBitmap;
		}
		case FILE_INTERFACE:
		{
			return fileInterfaceBitmap;
		}
		case PHYSICAL_INPUT:
		{
			return physicalInputBitmap;
		}
		case PHYSICAL_OUTPUT:
		{
			return physicalOutputBitmap;
		}
		case SYSTEM_MIXER:
		{
			return systemMixerBitmap;
		}
	}
	return 0;
}

// ***************************************************************************
// PROTECTED Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// PRIVATE Member Function Definitions
// ***************************************************************************

// ===========================================================================
// Constructor
// ===========================================================================

IconFactory::IconFactory(void) 
{
	// Do nothing.
}

// ***************************************************************************
// Helper Function Definitions
// ***************************************************************************

// ***************************************************************************
// Global Function Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Function Definitions
// ***************************************************************************
